
#ifdef HAVE_OGGVORBIS
#define OV_AUDIO_FORMAT " ogg"
#define OV_AUDIO_FORMAT_ARRAY , "ogg"
#else
#define OV_AUDIO_FORMAT ""
#define OV_AUDIO_FORMAT_ARRAY 
#endif

#define SUPPORTED_AUDIO_FORMATS "mp3" OV_AUDIO_FORMAT
#define SUPPORTED_AUDIO_FORMATS_ARRAY "mp3" OV_AUDIO_FORMAT_ARRAY, NULL 


/* status flags */
#define AFS_NOMORE 1
#define AFS_NEXT 2
#define AFS_REPOS 4
#define AFS_PLAYING 8
#define DBT_CHANGE 16

struct audio_format {
	struct timeval chunk_tv; /* length of one chunk of data */
	struct timeval eof_tv; /* timeout on eof */
	const char *name;
	void (*init)(void*);
	char *(*get_header_info)(int *);
	int (*get_file_info)(FILE*, char*, long unsigned*, int*);
	/*
	 * must return < 0 on errors, == 0 on eof, > 0 ok. If ret > 0, store
	 * buflen in given pointer. If that len is positive, *bufptr is not NULL and
	 * contains said chunk.
	*/
	void (*close_audio_file)(void);
	int (*reposition_stream)(long unsigned request);
	int (*read_chunk)(long unsigned chunk_num, size_t *len, char **bufptr);
};

void afs_handle_sigchild(pid_t);
int afs_open_fifo(char *, int []);
void afs_init(void);
int afs_send_chunk(void);
int afs_mainloop(struct timeval**);
const char *audio_format_name(int);
int afs_handle_sighup(void);
unsigned int afs_playing(void);
unsigned int afs_next(void);
unsigned int afs_repos(void);
unsigned int afs_paused(void);

